% You can experiment with the threshold value and structure
% element to improve the results

% Step 1
img = rgb2gray(imread('img_cells.jpg'));
figure, imagesc(img), title 'original image'

% Step 2
thresh = 210/255; % Some threshold.. You might find better
bw = im2bw(img, thresh);
bw = ~bw;

% Step 3
se = strel('disk', 10);
bw = imopen(bw,se);
figure, imagesc(bw), colorbar, title 'bw opened'

% Step 4
D = bwdist(~bw);

% Step 5
D =-D;
L = watershed(D);
L(~bw) = 0;

% Step 6
Lrgb = label2rgb (L, 'jet', 'w','shuffle');
figure, imshow(img), hold on
himage = imshow(Lrgb);
set(himage, 'AlphaData', 0.3);
title 'Watershed regions overlaid the original image'
